2014上海网络赛1004||hdu5045 contest【状态压缩dp】

来源:互联网 发布:关了蜂窝数据还跑流量 编辑:程序博客网 时间:2024/05/20 19:33

SubmitStatus

Description

In the ACM International Collegiate Programming Contest, each team consist of three students. And the teams are given 5 hours to solve between 8 and 12 programming problems.

On Mars, there is programming contest, too. Each team consist of N students. The teams are given M hours to solve M programming problems. Each team can use only one computer, but they can’t cooperate to solve a problem. At the beginning of the ith hour, they will get the ith programming problem. They must choose a student to solve this problem and others go out to have a rest. The chosen student will spend an hour time to program this problem. At the end of this hour, he must submit his program. This program is then run on test data and can’t modify any more.

Now, you have to help a team to find a strategy to maximize the expected number of correctly solved problems.

For each problem, each student has a certain probability that correct solve. If the ith student solve the jth problem, the probability of correct solve is Pij .

At any time, the different between any two students’ programming time is not more than 1 hour. For example, if there are 3 students and there are 5 problems. The strategy {1,2,3,1,2}, {1,3,2,2,3} or {2,1,3,3,1} are all legal. But {1,1,3,2,3},{3,1,3,1,2} and {1,2,3,1,1} are all illegal.

You should find a strategy to maximize the expected number of correctly solved problems, if you have know all probability
 

Input

The first line of the input is T (1 ≤ T ≤ 20), which stands for the number of test cases you need to solve.

The first line of each case contains two integers N ,M (1 ≤ N ≤ 10,1 ≤ M ≤ 1000),denoting the number of students and programming problem, respectively.

The next N lines, each lines contains M real numbers between 0 and 1 , the j th number in the i th line is P ij .
 

Output

For each test case, print a line “Case #t: ”(without quotes, t means the index of the test case) at the beginning. Then a single real number means the maximal expected number of correctly solved problems if this team follow the best strategy, to five digits after the decimal point. Look at the output for sample input for details.
 

Sample Input

12 30.6 0.3 0.40.3 0.7 0.9
 

Sample Output

Case #1: 2.20000

恕本人才疏学浅,实在没有看明白网络流的写法==而且都说了n<=10明显是状压啊==

题意:m小时之间每个小时有新出的一个题供n个人中的一个人做,每个人做出的概率已知,每一时刻任意两个人做出的题数之差不得多于1个,问最多答题的个数

之前的状压都是三重循环是同一个数来的,然而这个题让我重新认识了状压QAQ

1.状压读数的话一定要从0开始啊啊啊,要不取状态值会很费劲的

2.做过状压都知道,第一重循环和第三重循环都是正常的数,第二重循环是状态。从“凑数”的角度看,第二重循环和第三重循环也得是n,第一重循环是m。从正常的解释来看,第一重循环推的是每个题,第二重循环是某人做过哪些题,第三重循环是找一个人做当前的题

关于st==(1<<n)-1  st=0这句话是说“因为每两个人之间答题数目不能超过1,所以当状态达到1 << n - 1,即所有人都答过一题时,将重置为0。"

#include <iostream>#include<cstring>#include<cstdio>using namespace std;double num[11][1009],dp[1<<13][1009];int n,m;int main(){    //freopen("cin.txt","r",stdin);    int t,cas=1;    scanf("%d",&t);    while(t--)    {        scanf("%d%d",&n,&m);        for(int i=0;i<n;i++)            for(int j=0;j<m;j++)                scanf("%lf",&num[i][j]);        for(int j=0;j<=m;j++)            for(int i=0;i<(1<<n);i++)                dp[i][j]=-1.0;        dp[0][0]=0;        for(int i=0;i<m;i++)        {            for(int j=0;j<(1<<n);j++)// 0            {                if(dp[j][i]<0) continue;                for(int k=0;k<n;k++)                {                    if(j&(1<<k))continue;                    int st=j|(1<<k);                    if(st==(1<<n)-1) st=0;                    dp[st][i+1]=max(dp[st][i+1],dp[j][i]+num[k][i]);                }            }        }        double ans=0.0;        for(int i=0;i<(1<<n);i++)            if(ans<dp[i][m]) ans=dp[i][m];        printf("Case #%d: %.5lf\n",cas++,ans);    }    return 0;}



0 0